package com.zm.order.tool.server.config;

import com.alibaba.druid.pool.DruidDataSource;
import org.apache.ibatis.session.SqlSessionFactory;
import org.mybatis.spring.SqlSessionFactoryBean;
import org.mybatis.spring.SqlSessionTemplate;
import org.mybatis.spring.annotation.MapperScan;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.io.Resource;
import org.springframework.core.io.support.PathMatchingResourcePatternResolver;

import javax.sql.DataSource;

/**
 * @Description 数据源配置
 * @Author: ph
 * @Date: 2019/10/30 16:15
 */
@Configuration
@MapperScan(basePackages = {"com.zm.order.tool.server.tb"},
        sqlSessionTemplateRef = "tbDataSqlSessionTemplate")
@EnableConfigurationProperties(TbProperty.class)
public class TbDataSourceConfig {

    private static final Logger logger = LoggerFactory.getLogger(TbDataSourceConfig.class);
    @Autowired
    private TbProperty tbProperty;

    @Bean(name = "tbDataDataSource")
    public DataSource dataSource() {
        DruidDataSource dataSource = new DruidDataSource();
        dataSource.setUrl(tbProperty.getUrl());
        dataSource.setUsername(tbProperty.getUserName());
        dataSource.setPassword(tbProperty.getPassword());
        dataSource.setDriverClassName(tbProperty.getDriverClassName());
        logger.info("init tb data data source success");
        return dataSource;
    }

    @Bean("tbDataSqlSessionFactory")
    public SqlSessionFactory sqlSessionFactory(
            @Value("${mybatis.tb.mapper-locations}") String mapperLocations,
            @Value("${mybatis.config-location}") String configLocation
    ) throws Exception {
        SqlSessionFactoryBean sqlSessionFactoryBean = new SqlSessionFactoryBean();
        sqlSessionFactoryBean.setDataSource(dataSource());
        Resource[] mapperLocationsResource = new PathMatchingResourcePatternResolver().getResources(mapperLocations);
        sqlSessionFactoryBean.setMapperLocations(mapperLocationsResource);
        sqlSessionFactoryBean.setConfigLocation(
                new PathMatchingResourcePatternResolver().getResource(configLocation)
        );
        return sqlSessionFactoryBean.getObject();
    }

    @Bean("tbDataSqlSessionTemplate")
    public SqlSessionTemplate sqlSessionTemplate(@Qualifier("tbDataSqlSessionFactory") SqlSessionFactory sqlSessionFactory) {
        SqlSessionTemplate sqlSessionTemplate = new SqlSessionTemplate(sqlSessionFactory);
        return sqlSessionTemplate;
    }

}
